#ifndef TMC2208_H
#define TMC2208_H

#include "Arduino.h"

#define STOP_DELAY_TIME   50000L

#define STATE_DISABLE     1
#define STATE_STEP_HIGH   2
#define STATE_STEP_LOW    3
#define STATE_ENABLE      4

class TMC2208
{
  public:
    TMC2208(int _pDir, int _pStep, int _pEnable, unsigned long _stepdelay, int _nRev);

    boolean run();

    void move(long steps);

    void stop();

    int stepsToGo();

  private:
    int nState; //the curret phase setp
    int pDir; //output pin
    int pStep; //output pin
    int pEnable; //output pin
    int nRev;
    long stepstogo;   //the remaining steps to complete the curret movement.
    unsigned long steptime; //the delay time between steps
    unsigned long _lastStepTime; //the last step time in microseconds
};

#endif
